Skip to main content
`Ctrl`+`K`

# NEPSetWhichEigenpairs

Specifies which portion of the spectrum is to be sought.

## Synopsis

    #include "slepcnep.h"
    PetscErrorCode NEPSetWhichEigenpairs(NEP nep,NEPWhich which)

Logically Collective

## Input Parameters

- nep - the nonlinear eigensolver context

- which - the portion of the spectrum to be sought, see `NEPWhich` for possible values

## Options Database Keys

- -nep_largest_magnitude - sets largest eigenvalues in magnitude

- -nep_smallest_magnitude - sets smallest eigenvalues in magnitude

- -nep_largest_real - sets largest real parts

- -nep_smallest_real - sets smallest real parts

- -nep_largest_imaginary - sets largest imaginary parts

- -nep_smallest_imaginary - sets smallest imaginary parts

- -nep_target_magnitude - sets eigenvalues closest to target

- -nep_target_real - sets real parts closest to target

- -nep_target_imaginary - sets imaginary parts closest to target

- -nep_all - sets all eigenvalues in a region

## Notes

Not all eigensolvers implemented in `NEP` account for all the possible values of `which`. Also, some values make sense only for certain types of problems. If SLEPc is compiled for real numbers `NEP_LARGEST_IMAGINARY` and `NEP_SMALLEST_IMAGINARY` use the absolute value of the imaginary part for eigenvalue selection.

The target is a scalar value provided with `NEPSetTarget()`.

The criterion `NEP_TARGET_IMAGINARY` is available only in case PETSc and SLEPc have been built with complex scalars.

`NEP_ALL` is intended for use in the context of the `NEPCISS` solver for computing all eigenvalues in a region.

## See Also

NEP: Nonlinear Eigenvalue Problems, `NEPGetWhichEigenpairs()`, `NEPSetTarget()`, `NEPSetDimensions()`, `NEPSetEigenvalueComparison()`, `NEPWhich`

## Level

intermediate

## Location

src/nep/interface/nepopts.c

Index of all NEP routines Table of Contents for all manual pages Index of all manual pages